/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.filters.SimpleProjection;

import java.util.Arrays;
import java.util.Vector;

import javax.swing.DefaultComboBoxModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.visnow.vn.engine.core.ParameterProxy;

import org.visnow.vn.engine.core.Parameters;

import org.visnow.vn.lib.basic.filters.SimpleProjection.SimpleProjectionShared.Axis;
import static org.visnow.vn.lib.basic.filters.SimpleProjection.SimpleProjectionShared.*;

/**
 * @author Bartosz Borucki (babor@icm.edu.pl)
 * Warsaw University, Interdisciplinary Centre
 * for Mathematical and Computational Modelling
 * 
 * Modified by Szymon Jaranowski (s.jaranowski@icm.edu.pl;
 * University of Warsaw, Interdisciplinary Centre
 * for Mathematical and Computational Modelling)
 * since revision 25.
 */
public class GUI extends javax.swing.JPanel
{
    private Parameters parameters;
    
    private boolean silent = false;

    private int[] inFieldDims = null;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
//        DefaultComboBoxModel cbm = new DefaultComboBoxModel(Params.methodsStrings);
        DefaultComboBoxModel cbm = new DefaultComboBoxModel(METHODS_NAMES);
        methodCB.setModel(cbm);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        methodCB = new javax.swing.JComboBox();
        jPanel1 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        iRB_L0 = new javax.swing.JRadioButton();
        jRB_L0 = new javax.swing.JRadioButton();
        kRB_L0 = new javax.swing.JRadioButton();
        jPanel2 = new javax.swing.JPanel();
        secondLevelCB = new javax.swing.JCheckBox();
        iRB_L1 = new javax.swing.JRadioButton();
        jRB_L1 = new javax.swing.JRadioButton();
        kRB_L1 = new javax.swing.JRadioButton();

        setLayout(new java.awt.GridBagLayout());

        jPanel3.setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("Regular field projection");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 5);
        jPanel3.add(jLabel1, gridBagConstraints);

        jLabel3.setText("projection method:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 5, 0, 0);
        jPanel3.add(jLabel3, gridBagConstraints);

        methodCB.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        methodCB.setMinimumSize(new java.awt.Dimension(150, 24));
        methodCB.setPreferredSize(new java.awt.Dimension(150, 24));
        methodCB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                methodCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 0, 10);
        jPanel3.add(methodCB, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        add(jPanel3, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jLabel4.setText("first projection axis:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        jPanel1.add(jLabel4, gridBagConstraints);

        buttonGroup1.add(iRB_L0);
        iRB_L0.setText("i");
        iRB_L0.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                iRB_L0ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        jPanel1.add(iRB_L0, gridBagConstraints);

        buttonGroup1.add(jRB_L0);
        jRB_L0.setText("j");
        jRB_L0.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRB_L0ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        jPanel1.add(jRB_L0, gridBagConstraints);

        buttonGroup1.add(kRB_L0);
        kRB_L0.setText("k");
        kRB_L0.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                kRB_L0ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        jPanel1.add(kRB_L0, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 5, 0, 0);
        add(jPanel1, gridBagConstraints);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        secondLevelCB.setText(" second projection axis");
        secondLevelCB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                secondLevelCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        jPanel2.add(secondLevelCB, gridBagConstraints);

        buttonGroup2.add(iRB_L1);
        iRB_L1.setText("i");
        iRB_L1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                iRB_L1ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        jPanel2.add(iRB_L1, gridBagConstraints);

        buttonGroup2.add(jRB_L1);
        jRB_L1.setText("j");
        jRB_L1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRB_L1ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        jPanel2.add(jRB_L1, gridBagConstraints);

        buttonGroup2.add(kRB_L1);
        kRB_L1.setText("k");
        kRB_L1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                kRB_L1ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        jPanel2.add(kRB_L1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 5, 0, 0);
        add(jPanel2, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    void updateGUI(ParameterProxy parameters, boolean resetGUIControls)
    {
        methodCB.setEnabled(true);
        methodCB.setSelectedIndex(Arrays.asList(METHODS_NAMES).indexOf(parameters.get(METHOD)));

        iRB_L0.setEnabled(true);
        jRB_L0.setEnabled(true);
        kRB_L0.setEnabled(false);
        secondLevelCB.setEnabled(false);
        if (parameters.get(META_NUMBER_OF_DIMENSIONS) == 3) {
            kRB_L0.setEnabled(true);
            secondLevelCB.setEnabled(true);
        }

        switch (parameters.get(AXIS_L0)) {
            case I:
                iRB_L0.setSelected(true);
                break;
            case J:
                jRB_L0.setSelected(true);
                break;
            case K:
                kRB_L0.setSelected(true);
                break;
        }
        switch (parameters.get(AXIS_L1)) {
            case I:
                iRB_L1.setSelected(true);
                break;
            case J:
                jRB_L1.setSelected(true);
                break;
            case K:
                kRB_L1.setSelected(true);
                break;
        }

        if (parameters.get(LEVELS) == 2) {
            secondLevelCB.setSelected(true);
            iRB_L1.setEnabled(parameters.get(META_NUMBER_OF_DIMENSIONS) == 3 && parameters.get(AXIS_L0) != Axis.I);
            jRB_L1.setEnabled(parameters.get(META_NUMBER_OF_DIMENSIONS) == 3 && parameters.get(AXIS_L0) != Axis.J);
            kRB_L1.setEnabled(parameters.get(META_NUMBER_OF_DIMENSIONS) == 3 && parameters.get(AXIS_L0) != Axis.K);
        } else {
            secondLevelCB.setSelected(false);
            iRB_L1.setEnabled(false);
            jRB_L1.setEnabled(false);
            kRB_L1.setEnabled(false);
        }
    }    
    
    private void iRB_L0ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_iRB_L0ActionPerformed
        if (iRB_L0.isSelected())
            parameters.set(AXIS_L0, Axis.I);
    }//GEN-LAST:event_iRB_L0ActionPerformed

    private void jRB_L0ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRB_L0ActionPerformed
        if (jRB_L0.isSelected())
            parameters.set(AXIS_L0, Axis.J);
    }//GEN-LAST:event_jRB_L0ActionPerformed

    private void kRB_L0ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_kRB_L0ActionPerformed
        if (kRB_L0.isSelected())
            parameters.set(AXIS_L0, Axis.K);
    }//GEN-LAST:event_kRB_L0ActionPerformed

    private void methodCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_methodCBActionPerformed
        parameters.set(METHOD, (String) methodCB.getSelectedItem());
    }//GEN-LAST:event_methodCBActionPerformed

    private void iRB_L1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_iRB_L1ActionPerformed
        if (iRB_L1.isSelected())
            parameters.set(AXIS_L1, Axis.I);
    }//GEN-LAST:event_iRB_L1ActionPerformed

    private void jRB_L1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRB_L1ActionPerformed
        if (jRB_L1.isSelected())
            parameters.set(AXIS_L1, Axis.J);
    }//GEN-LAST:event_jRB_L1ActionPerformed

    private void kRB_L1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_kRB_L1ActionPerformed
        if (kRB_L1.isSelected())
            parameters.set(AXIS_L1, Axis.K);
    }//GEN-LAST:event_kRB_L1ActionPerformed

    private void secondLevelCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_secondLevelCBActionPerformed
        parameters.set(LEVELS, secondLevelCB.isSelected() ? 2 : 1);
    }//GEN-LAST:event_secondLevelCBActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.JRadioButton iRB_L0;
    private javax.swing.JRadioButton iRB_L1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JRadioButton jRB_L0;
    private javax.swing.JRadioButton jRB_L1;
    private javax.swing.JRadioButton kRB_L0;
    private javax.swing.JRadioButton kRB_L1;
    private javax.swing.JComboBox methodCB;
    private javax.swing.JCheckBox secondLevelCB;
    // End of variables declaration//GEN-END:variables

    public void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }
}